SystemOrganization addCategory: #'PharoBot-Core'!

!Point class methodsFor: '*pharobot-core' stamp: 'FacundoMainere 4/13/2012 13:02'!
r: t1 theta: t2
	^ (t1 * t2 sin) negated @  (t1 * t2 cos) negated! !

Object subclass: #Bateria
	instanceVariableNames: 'carga cargaMaxima'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!Bateria commentStamp: '<historical>' prior: 0!
Soy la responsable de almacenar la carga necesaria para los movimientos del robot.!

!Bateria class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
crearBateriaConCargaMaxima: unaCarga

"Las baterias nuevas vienen con la mitad de carga"

|bateria|
bateria:= self new.
bateria cargaMaxima: unaCarga.
bateria carga: unaCarga / 2.
^ bateria.! !

!Bateria methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:24'!
carga
	^ carga! !

!Bateria methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:24'!
carga: anObject
	carga := anObject! !

!Bateria methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
cargaMaxima
	^ cargaMaxima! !

!Bateria methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
cargaMaxima: anObject
	cargaMaxima := anObject! !

!Bateria methodsFor: 'private' stamp: 'NahuelGarbezza 7/1/2012 18:54'!
cargaMaximaPorDefecto

	^1000! !

!Bateria methodsFor: 'operations' stamp: 'NahuelGarbezza 7/1/2012 18:39'!
consumir: unaCantidad

	self carga: self carga - unaCantidad! !

!Bateria methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 7/1/2012 18:58'!
initialize

	self cargaMaxima: self cargaMaximaPorDefecto.
	self recargar.
	^self! !

!Bateria methodsFor: 'operations' stamp: 'NahuelGarbezza 7/1/2012 18:38'!
puedeConsumir: unaCantidad

	^self carga >= unaCantidad! !

!Bateria methodsFor: 'recarga' stamp: 'NahuelGarbezza 7/1/2012 18:41'!
recargar

	self carga: self cargaMaxima! !

Object subclass: #Camino
	instanceVariableNames: 'puntos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!Camino commentStamp: '<historical>' prior: 0!
Soy el recorrido que realiza el robot con el pincel bajo. No solo uno un punto de origen con uno de destino, sino que puedo tener puntos intermedios (cuando el robot cambia su direccion).!

!Camino class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 7/1/2012 20:32'!
new: unPunto

	^super new initialize: unPunto! !

!Camino methodsFor: 'operaciones' stamp: 'NahuelGarbezza 7/1/2012 20:33'!
agregarPunto:unPunto

	self puntos add: unPunto! !

!Camino methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 7/1/2012 20:32'!
initialize: unPunto

	self puntos: OrderedCollection new.
	self puntos add: unPunto.
	^self! !

!Camino methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:12'!
puntos
	^ puntos! !

!Camino methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:12'!
puntos: anObject
	puntos := anObject! !

Object subclass: #EstadoRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!EstadoRobot commentStamp: '<historical>' prior: 0!
Represento un posible estado en el que se encuentre el robot del que formo parte.!

!EstadoRobot methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:21'!
bajarPincelDe: unRobot

	self subclassResponsibility
! !

!EstadoRobot methodsFor: 'testing' stamp: 'NahuelGarbezza 7/1/2012 18:59'!
estaAbajo

	self subclassResponsibility
! !

!EstadoRobot methodsFor: 'testing' stamp: 'NahuelGarbezza 7/1/2012 18:59'!
estaArriba 

	self subclassResponsibility
! !

!EstadoRobot methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 18:59'!
mover: unaDistancia alRobot: unRobot

	self subclassResponsibility! !

!EstadoRobot methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:21'!
subirPincelDe: unRobot

	self subclassResponsibility
! !

EstadoRobot subclass: #PincelAbajo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PincelAbajo methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:23'!
bajarPincelDe: unRobot

	"Nada que hacer"! !

!PincelAbajo methodsFor: 'testing' stamp: 'NahuelGarbezza 7/1/2012 19:00'!
estaAbajo

	^true! !

!PincelAbajo methodsFor: 'testing' stamp: 'NahuelGarbezza 7/1/2012 19:00'!
estaArriba

	^false! !

!PincelAbajo methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:32'!
mover: unaDistancia alRobot: unRobot
	
	unRobot realizarMovimiento: unaDistancia.
	unRobot caminoActual agregarPunto: unRobot posicion! !

!PincelAbajo methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:28'!
subirPincelDe: unRobot

	unRobot estado: PincelArriba new.! !

EstadoRobot subclass: #PincelArriba
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!PincelArriba methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:24'!
bajarPincelDe: unRobot

	unRobot comenzarNuevoCamino.
	unRobot estado: PincelAbajo new.! !

!PincelArriba methodsFor: 'testing' stamp: 'NahuelGarbezza 7/1/2012 19:36'!
estaAbajo

	^false! !

!PincelArriba methodsFor: 'testing' stamp: 'NahuelGarbezza 7/1/2012 19:36'!
estaArriba

	^true! !

!PincelArriba methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:36'!
mover: unaDistancia alRobot: unRobot
	
	unRobot realizarMovimiento: unaDistancia
! !

!PincelArriba methodsFor: 'actions' stamp: 'NahuelGarbezza 7/1/2012 19:28'!
subirPincelDe: unRobot

	"Nada que hacer"! !

Object subclass: #MundoRobot
	instanceVariableNames: 'robots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!MundoRobot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:56'!
robots
	^ robots! !

!MundoRobot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 19:56'!
robots: anObject
	robots := anObject! !

Object subclass: #Robot
	instanceVariableNames: 'posicion estado direccion color caminos bateria caminoActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core'!

!Robot commentStamp: '<historical>' prior: 0!
Soy un robot capaz de hacer cosas simples como moverme a traves del espacio, pudiendo dejar marcas del camino que voy realizando. Tengo una bateria que se va consumiendo cada vez que me muevo, una vez que se agota debe ser recargada.!

!Robot methodsFor: 'pincel' stamp: 'NahuelGarbezza 7/1/2012 19:20'!
bajarPincel

	self estado bajarPincelDe: self! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/7/2012 13:10'!
bateria
	^ bateria! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:44'!
bateria: unaBateria
	bateria := unaBateria! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
caminoActual
	^ caminoActual! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:45'!
caminoActual: unCamino
	caminoActual := unCamino! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
caminos
	^ caminos! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:45'!
caminos: unaColeccionDeCaminos
	caminos := unaColeccionDeCaminos! !

!Robot methodsFor: 'bateria' stamp: 'NahuelGarbezza 7/1/2012 18:41'!
cargarBateria

	self bateria recargar! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
color
	^ color! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:45'!
color: unColor
	color := unColor! !

!Robot methodsFor: 'private' stamp: 'NahuelGarbezza 7/1/2012 19:18'!
comenzarNuevoCamino

	self caminoActual: (Camino new: self posicion).
	self caminos add: self caminoActual! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
direccion
	^ direccion! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:46'!
direccion: unaDireccion
	direccion := unaDireccion! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
estado
	^ estado! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:46'!
estado: unEstado
	estado := unEstado! !

!Robot methodsFor: 'private' stamp: 'NahuelGarbezza 7/1/2012 19:19'!
estadoInicial

	^PincelArriba new! !

!Robot methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 7/1/2012 19:19'!
initialize

	self bateria: Bateria new.
	self color: Color random.
	self posicion: 0 @ 0.
	self estado: self estadoInicial.
	self direccion: 90.
	self caminos: OrderedCollection new.
	^self! !

!Robot methodsFor: 'private' stamp: 'FacundoMainere 4/7/2012 13:18'!
limpiarCaminos
	self caminoActual: (Camino new: self posicion).
	self caminos: OrderedCollection new.
	self caminos add: caminoActual! !

!Robot methodsFor: 'movimientos' stamp: 'NahuelGarbezza 7/1/2012 19:48'!
mover: unaDistancia

	(self bateria puedeConsumir: unaDistancia)
		ifTrue: [
			self estado mover: unaDistancia alRobot: self.
			self bateria consumir: unaDistancia.]
		ifFalse: [self error: '!!No hay suficiente bateria!!'].! !

!Robot methodsFor: 'pincel' stamp: 'NahuelGarbezza 7/1/2012 19:46'!
pincelEstaAbajo

	^self estado estaAbajo! !

!Robot methodsFor: 'pincel' stamp: 'NahuelGarbezza 7/1/2012 19:46'!
pincelEstaArriba

	^self estado estaArriba! !

!Robot methodsFor: 'accessing' stamp: 'FacundoMainere 4/5/2012 20:00'!
posicion
	^ posicion! !

!Robot methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/1/2012 19:47'!
posicion: unaPosicion
	posicion := unaPosicion! !

!Robot methodsFor: 'printing' stamp: 'NahuelGarbezza 7/26/2012 13:14'!
printOn: aStream

	aStream
		nextPutAll: self class printString;
		nextPutAll: ' en ';
		nextPutAll: self posicion printString.! !

!Robot methodsFor: 'private' stamp: 'NahuelGarbezza 7/1/2012 19:33'!
realizarMovimiento: unaDistancia

	self posicion:
		(self posicion + (Point r: unaDistancia theta: Float pi / 180 * (self direccion negated - 90))) rounded.! !

!Robot methodsFor: 'pincel' stamp: 'NahuelGarbezza 7/1/2012 19:27'!
subirPincel

	self estado subirPincelDe: self! !
